"
 COPYRIGHT (c) 1996 by Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"


Object subclass:#Namespace
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Kernel-Classes'
!

!Namespace class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1996 by Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

!

documentation
"
    A Namespace is actually a dummy class, providing a home
    for its private classes. This has two advantages:
        - we only need one mechanism for both namespaces
          and private classes

        - there are no possible conflicts between a class
          and a namespace named alike.


    [author:]
        Claus Gittinger

    [see also:]
        Behavior ClassDescription Class Metaclass
        PrivateMetaclass
"

! !

!Namespace class methodsFor:'instance creation'!

name:aSymbol
    "create a new nameSpace, named aSymbol"

    |newNamespace|

    newNamespace := self subclass:aSymbol
			 instanceVariableNames:''
			 classVariableNames:''
			 poolDictionaries:''
			 category:(aSymbol , ' (* namespace *)').

    ^ newNamespace

    "
     Namespace name:'foo'
     (Namespace name:'foo') category:'my name space'
    "
!

new
    self error:'namespaces are not to be created with new'
! !

!Namespace class methodsFor:'accessing'!

at:classNameSymbol
    ^ self privateClassesAt:classNameSymbol
!

at:classNameSymbol ifAbsent:exceptionBlock
    |cls|

    cls := self privateClassesAt:classNameSymbol.
    cls isNil ifTrue:[
        ^ exceptionBlock value
    ].
    ^ cls
!

at:classNameSymbol put:aClass
    ^ self privateClassesAt:classNameSymbol put:aClass
! !

!Namespace class methodsFor:'enumerating'!

allBehaviorsDo:aBlock
    self privateClassesDo:aBlock

    "Created: 26.10.1996 / 12:29:01 / cg"
! !

!Namespace class methodsFor:'fileOut'!

basicFileOutDefinitionOn:aStream
    aStream nextPutAll:('Namespace name:' , self name storeString)
! !

!Namespace class methodsFor:'queries'!

isNamespace
    ^ true

    "Created: 26.10.1996 / 11:13:36 / cg"
! !

!Namespace class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libbasic/Attic/Namespace.st,v 1.5 1996-11-06 20:42:22 cg Exp $'
! !
